﻿Imports System.ComponentModel
Imports Telerik.WinControls.UI
Imports Telerik.WinControls

Public Class Form1
    Sub New()
         
        InitializeComponent()

        Dim products As New BindingList(Of Product)()
        products.Add(New Product(567, "Bicycle", 5))
        products.Add(New Product(456, "Car", 5000))
        products.Add(New Product(789, "Bike", 1500))
        products.Add(New Product(754, "Motor-cycle", 1500))
        RadTreeView1.DataSource = products
        RadTreeView1.DisplayMember = "Description"

        Me.RadTreeView1.AllowDragDrop = True
        'this.radTreeView1.MultiSelect = true;

        Dim products2 As New BindingList(Of Product)()
        products2.Add(New Product(567, "T-shirt", 5))
        products2.Add(New Product(456, "Jacket", 5000))
        products2.Add(New Product(789, "Jeans", 1500))
        Me.RadTreeView2.DataSource = products2
        Me.RadTreeView2.DisplayMember = "Description"

    End Sub
    Class CustomTreeView
        Inherits RadTreeView
        Protected Overrides Function CreateTreeViewElement() As RadTreeViewElement
            Return New CustomTreeViewElement()
        End Function

        Public Overrides Property ThemeClassName As String
            Get
                Return GetType(RadTreeView).FullName
            End Get
            Set(value As String)
                MyBase.ThemeClassName = value
            End Set
        End Property
    End Class

    Class CustomTreeViewElement
        Inherits RadTreeViewElement
        Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
            Get
                Return GetType(RadTreeViewElement)
            End Get
        End Property

        Protected Overrides Function CreateDragDropService() As TreeViewDragDropService
            Return New CustomDragDropService(Me)
        End Function
    End Class

    Class CustomDragDropService
        Inherits TreeViewDragDropService
        Private owner As RadTreeViewElement
        Private draggedNode As RadTreeNode

        Public Sub New(owner As RadTreeViewElement)
            MyBase.New(owner)
            Me.owner = owner
        End Sub

        'Save the dragged node
        Protected Overrides Sub PerformStart()
            MyBase.PerformStart()

            Dim draggedNodeElement As TreeNodeElement = TryCast(Me.Context, TreeNodeElement)
            Me.draggedNode = draggedNodeElement.Data
        End Sub

        'Clean the saved node
        Protected Overrides Sub PerformStop()
            MyBase.PerformStop()
            Me.draggedNode = Nothing
        End Sub

        Protected Overrides Sub OnPreviewDragHint(e As PreviewDragHintEventArgs)

            MyBase.OnPreviewDragHint(e)
        End Sub
        'If tree element is hovered, allow drop
        Protected Overrides Sub OnPreviewDragOver(e As RadDragOverEventArgs)
            MyBase.OnPreviewDragOver(e)

            Dim targetElement As RadTreeViewElement = TryCast(e.HitTarget, RadTreeViewElement)
            If targetElement IsNot Nothing AndAlso Not targetElement.Equals(Me.owner) Then
                e.CanDrop = True
            ElseIf TypeOf e.HitTarget Is TreeNodeElement Then
                e.CanDrop = True
            End If
        End Sub

        'Create copies of the selected node(s) and add them to the hovered node/tree
        Protected Overrides Sub OnPreviewDragDrop(e As RadDropEventArgs)
            Dim targetNodeElement As TreeNodeElement = TryCast(e.HitTarget, TreeNodeElement)
            Dim targetTreeView As RadTreeViewElement = If(targetNodeElement Is Nothing, TryCast(e.HitTarget, RadTreeViewElement), targetNodeElement.TreeViewElement)

            If targetTreeView.Equals(Me.owner) Then
                MyBase.OnPreviewDragDrop(e)
                Return
            End If

            If targetTreeView Is Nothing Then
                Return
            End If

            Dim draggedNodes As List(Of RadTreeNode) = Me.GetDraggedNodes(draggedNode)

            targetTreeView.BeginUpdate()
            Me.owner.BeginUpdate()

            For Each node As RadTreeNode In draggedNodes
                Dim product As Product = TryCast(node.DataBoundItem, Product)
                Dim targetList As BindingList(Of Product) = TryCast(targetTreeView.DataSource, BindingList(Of Product))
                If Not targetList.Contains(product) Then
                    If targetNodeElement IsNot Nothing Then
                        Dim nodeOver As RadTreeNode = targetNodeElement.Data
                        Dim insertIndex As Integer = targetList.IndexOf(TryCast(nodeOver.DataBoundItem, Product))
                        If insertIndex < targetList.Count Then
                            targetList.Insert(insertIndex, product)
                        Else
                            targetList.Add(product)
                        End If
                    Else
                        targetList.Add(product)
                    End If
                End If
            Next

            Me.owner.EndUpdate()
            targetTreeView.EndUpdate()
        End Sub
    End Class

    Public Class Product
        Private _id As Integer
        Private _description As String
        Private _price As Single

        Public Property ID() As Integer
            Get
                Return _id
            End Get
            Set(value As Integer)
                _id = value
            End Set
        End Property

        Public Property Description() As String
            Get
                Return _description
            End Get
            Set(value As String)
                _description = value
            End Set
        End Property

        Public Property Price() As Single
            Get
                Return _price
            End Get
            Set(value As Single)
                _price = value
            End Set
        End Property

        Public Sub New(id As Integer, description As String, price As Single)
            _id = id
            _description = description
            _price = price
        End Sub
    End Class


End Class
